<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">
  <!-- Import DataTable Library -->
  <script src="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="cotainer">
    <div class="text-center mt-2 mb-2">
      <h2>Danh sách đơn hàng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row">
        <div class="row col-5 form-group">
          <div class="col-sm-4">
            <label for="voucherCodeInput">Trạng thái order</label>
          </div>
          <div class="col-sm-8">
            <select id="status-order-select" class="form-control">
              <option value="open">Open</option>
              <option value="confirmed">Confirmed</option>
              <option value="cancel">Cancel</option>
            </select>
          </div>
        </div>
        <div class="row col-5 form-group">
          <div class="col-sm-4">
            <label for="voucherCodeInput">Loại Pizza</label>
          </div>
          <div class="col-sm-8">
            <select id="pizza-type-select" class="form-control">
              <option value="Hawaii">Hawaii</option>
              <option value="Bacon">Bacon</option>
              <option value="Seafood">Seafood</option>
            </select>
          </div>
        </div>
        <div class="col-sm-2">
          <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead>
          <tr>
            <th>Order code</th>
            <th>Kich co</th>
            <th>Loai Pizza</th>
            <th>Nuoc uong</th>
            <th>Thanh tien</th>
            <th>Ho va ten</th>
            <th>So dien thoai</th>
            <th>Trang thai</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <!-- Vùng Modal -->
    <!-- Create Course modal -->
    <div>
      <div id="create-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Create new Course</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">

            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
              <button class="btn btn-primary" id="btn-create-user">Create Voucher</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Update Course modal -->
    <div>
      <div id="detail-order-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Order Detail!!!</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="form-group col-10">
                  <div class="row mt-3">
                    <label for="">Order Code:</label>
                    <input type="text" id="inp-code" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Cỡ Combo:</label>
                    <input type="text" id="inp-combo" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Đường kính:</label>
                    <input type="text" id="inp-size" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Sườn nướng (miếng):</label>
                    <input type="text" id="inp-suon" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Loại đồ uống:</label>
                    <input type="text" id="inp-drink" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Số lượng đồ uống:</label>
                    <input type="text" id="inp-drink-type" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Voucher Id:</label>
                    <input type="text" id="inp-voucher" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Loại Pizza:</label>
                    <input type="text" id="inp-pizza-type" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Salad:</label>
                    <input type="text" id="inp-salad" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Thành tiền:</label>
                    <input type="text" id="inp-price" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Giảm giá:</label>
                    <input type="text" id="inp-discount" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Họ tên:</label>
                    <input type="text" id="inp-name" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Email:</label>
                    <input type="text" id="inp-email" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Số điện thoại:</label>
                    <input type="text" id="inp-phone" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Địa chỉ:</label>
                    <input type="text" id="inp-address" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Lời nhắn:</label>
                    <input type="text" id="inp-message" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Trạng thái đơn hàng:</label>
                    <input type="text" id="inp-status" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Ngày tạo:</label>
                    <input type="text" id="inp-created-date" class="form-control" disabled>
                  </div>
                  <div class="row mt-3">
                    <label for="">Ngày cập nhật:</label>
                    <input type="text" id="inp-updated-date" class="form-control" disabled>
                  </div>
                
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-detail-cancel" data-dismiss="modal">Hủy bỏ</button>
              <button class="btn btn-primary" id="btn-detail-confirm">Xác nhận</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <label>Bạn có chắc chắn muốn xóa Khóa học này không?</label>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-confirm-delete">Confirm</button>
              <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    // base url API
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    //Mang chua du lieu all order gui ve
    var gAllOrder = [];
    // id Order
    var gId;
    // Mảng gRoleObjects là mảng chứa dữ liệu của tableData
    var gRoleObjects = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      //lay danh sach order
      getAllOrder();
      console.log(gAllOrder);
      //load du lieu vao bang
      loadDataToTable();
      //filter order
      onClickButtonGetTypeId();
      //click btn confirm order
      onClickBtnConfirm();
      //click btn cancel order
      onClickBtnCancel();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //click button filter id
    function onClickButtonGetTypeId() {
      $("#btn-filter-order").on("click", function () {
        var vData = {
          statusOrder: "",
          pizzaType: "",
        }
        //them du lieu filter
        addDataFilterToObj(vData);
        //filter du lieu
        filterData(vData)
      })
    }
    //click button confirm oder
    function onClickBtnConfirm(){
      $("#btn-detail-confirm").on("click",function(){
        //gui Api confirm
        onUpdateOrderClick(gId, "confirm");
        alert("Xac nhan thanh cong!");
        //dong modal detail
        $("#detail-order-modal").modal("hide");
        //load lai web
        window.location.href = "task41.55.order.list.html";
      })
    }
    //click button cancel oder
    function onClickBtnCancel(){
      $("#btn-detail-cancel").on("click",function(){
        //gui Api confirm
        onUpdateOrderClick(gId, "cancel");
        alert("Huy don hang thanh cong!");
        //load lai web
        window.location.href = "task41.55.order.list.html";
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //gui Api lay toan do thong tin order
    function getAllOrder() {
      $.ajax({
        url: gBASE_URL,
        type: 'GET',
        dataType: 'json',
        async: false,
        success: function (res) {
          gAllOrder = res;
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText)
        }
      });
    }
    //gui Api lay du lieu 1 order
    function getOrderDetail(vOrderCode) {
      $.ajax({
        url: gBASE_URL + "/" + vOrderCode,
        type: 'GET',
        dataType: 'json',
        async: false,
        success: function (res) {
          //do du lieu ra form detail
          getDataToFormDetail(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText)
        }
      });
    }
    // Mẫu gọi để cập nhật trạng thái confirm hoặc cancel cho 01 order (update)
    function onUpdateOrderClick(vId, vStatusOrder) {
      var vObjectRequest = {
        trangThai: vStatusOrder
      }

      // var vXmlHttpUpdateOrder = new XMLHttpRequest();
      // vXmlHttpUpdateOrder.open("PUT", gBASE_URL + "/" + vId);
      // vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      // vXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
      // vXmlHttpUpdateOrder.onreadystatechange =
      //   function () {
      //     if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
      //       var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
      //       console.log(vUpdatedOrder);
      //     }
      //   }
      $.ajax({
        url: gBASE_URL + "/" + vId,
        type: 'PUT',
        contentType: 'application/json',
        data: JSON.stringify(vObjectRequest),
        success: function (res) {
          console.log(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText)
        }
      });
    }
    //load du lieu vao data table
    function loadDataToTable() {
      $("#user-table").DataTable({
        //cho phép tìm kiểm
        searching: false,
        columns: [
          { data: gRoleObjects[0] },
          { data: gRoleObjects[1] },
          { data: gRoleObjects[2] },
          { data: gRoleObjects[3] },
          { data: gRoleObjects[4] },
          { data: gRoleObjects[5] },
          { data: gRoleObjects[6] },
          { data: gRoleObjects[7] },
          { data: gRoleObjects[8] }
        ],
        columnDefs: [
          {
            targets: 8,
            className: "text-center",
            defaultContent: `
                  <button class='btn btn-info detail-btn'>Chi tiet</button>
                  `,
          }
        ],
      })
      //them data vao table data
      addDataToTable(gAllOrder);

      //khi button detail click
      $("#user-table").on("click", ".detail-btn", function () {
        var vTable = $("#user-table").DataTable();
        var vRow = $(this).parents("tr");
        var vDataRow = vTable.row(vRow).data();
        gId = vDataRow.id;
        //xu ly modal va hien form detail
        modalDetail(vDataRow.orderCode);
      })
    }
    //them data vao table
    function addDataToTable(paramsObj) {
      var vTable = $("#user-table").DataTable();
      vTable.clear();
      vTable.rows.add(paramsObj);
      vTable.draw();
    }
    //filter du lieu
    function filterData(paramObj) {
      console.log(paramObj)
      var vNewObj = [];
      //tao doi tuong moi luu tru doi tuong filter
      vNewObj = gAllOrder.filter(function (paramOrder) {
        return (paramObj.statusOrder == paramOrder.trangThai &&
          paramObj.pizzaType == paramOrder.loaiPizza);
      });
      //them doi tuong da filter vao table
      addDataToTable(vNewObj);
    }
    //them du lieu filter
    function addDataFilterToObj(paramObj) {
      paramObj.statusOrder = $("#status-order-select").val();
      paramObj.pizzaType = $("#pizza-type-select").val();
    }
    //modal detail
    function modalDetail(vOrderCode) {
      //hien modal detail
      $("#detail-order-modal").modal("show");
      //goi Api lay du lieu Order
      getOrderDetail(vOrderCode)
    }
    //do du lieu ra form detail
    function getDataToFormDetail(vOrderObj) {
      console.log(vOrderObj);
      $("#inp-code").val(vOrderObj.orderCode);
      $("#inp-combo").val(vOrderObj.kichCo);
      $("#inp-size").val(vOrderObj.duongKinh);
      $("#inp-suon").val(vOrderObj.suon);
      $("#inp-drink").val(vOrderObj.soLuongNuoc);
      $("#inp-drink-type").val(vOrderObj.idLoaiNuocUong);
      $("#inp-voucher").val(vOrderObj.idVourcher);
      $("#inp-pizza-type").val(vOrderObj.loaiPizza);
      $("#inp-salad").val(vOrderObj.salad);
      $("#inp-price").val(vOrderObj.thanhTien);
      $("#inp-discount").val(vOrderObj.giamGia);
      $("#inp-name").val(vOrderObj.hoTen);
      $("#inp-email").val(vOrderObj.email);
      $("#inp-phone").val(vOrderObj.soDienThoai);
      $("#inp-address").val(vOrderObj.diaChi);
      $("#inp-message").val(vOrderObj.loiNhan);
      $("#inp-status").val(vOrderObj.trangThai);
      $("#inp-created-date").val(formatDate(vOrderObj.ngayTao));
      $("#inp-updated-date").val(formatDate(vOrderObj.ngayCapNhat));
    };
    //hàm chuyển đổi giây sang ngày tháng
    function formatDate(params) {
      var d = new Date(parseInt(params));

      var year = d.getFullYear();
      var month = d.getMonth() + 1;
      var day = d.getDate();
      var hour = d.getHours();
      var minutes = d.getMinutes();

      var finalDate = year + "-" + month + "-" + day + " " + hour + ":" + minutes;
      return finalDate;
    }
  </script>
</body>

</html>